//这段代码用于控制MyCobot机械臂，通过设置和移动机械臂的关节角度来演示基本的控制操作。在主循环中不断执行两个操作：将第一个关节移动到100度，然后将所有关节归零。

#include <MyCobotBasic.h>   // 引入MyCobotBasic库,用于控制MyCobot机械臂。

MyCobotBasic myCobot;       // 创建MyCobotBasic对象
Angles angles = {0, 0, 0, 0, 0, 0};  // 定义一个Angles结构体，表示所有关节的初始角度为0

void setup()   //setup函数是Arduino程序的初始化函数，只在程序开始运行时执行一次
{
    myCobot.setup(); //初始化MyCobot，必须调用此API,这是必须步骤
    delay(100);   // 延迟100毫秒
    myCobot.powerOn();//给MyCobot上电
    delay(100);   // 延迟100毫秒
}

void loop()  //loop函数是Arduino程序的主循环函数，将不断重复执行函数中的内容
{
    myCobot.writeAngle((Joint)1, 100, 30); //控制单个关节，设置J1关节到100度，速度为30
    delay(200); // 等待200毫秒，让关节移动到位，然后进行下一个步骤
    myCobot.writeAngles(angles, 50); // 设置所有关节角度为0度，速度为50
    delay(5000);    // 等待5000毫秒，让所有关节移动到位
}
