//这段代码的作用是初始化并为MyCobot机械臂上电，然后在主循环中不断执行两个操作：将x轴坐标移动到30mm，然后将机械臂移动到预定义的目标坐标位置。

#include <MyCobotBasic.h>  // 引入MyCobotBasic库

MyCobotBasic myCobot;  // 创建MyCobotBasic对象

Coords coords = {194.700, -67.400, 131.300, -177.260, -3.760, -110.880};  // 定义一个Coords结构体，表示机械臂的目标坐标位置

void setup() {
    myCobot.setup();  // 初始化MyCobot，必须调用此API
    delay(100);  // 延迟100毫秒
    myCobot.powerOn();  // 给MyCobot上电
    delay(100);  // 延迟100毫秒
    myCobot.writeAngles({0, -10, -123, 45, 0, 20}, 50);  // 设置机械臂的初始姿态，关节角度为{0, -10, -123, 45, 0, 20}，速度为50
    delay(6000);  // 延迟6000毫秒，让机械臂移动到初始姿态
}

void loop() {
    myCobot.writeCoord((Axis)1, 30, 30);  // 控制机械臂的x轴坐标移动到30mm，速度为30
    delay(300);  // 延迟300毫秒，让x轴移动到位后再进行下一步操作
    myCobot.writeCoords(coords, 30);  // 控制机械臂移动到定义的目标坐标位置，速度为30
    delay(5000);  // 延迟5000毫秒，让机械臂移动到目标坐标位置后再进行下一步操作
}
