#include <MyCobotBasic.h> // 引入MyCobotBasic库，以便使用该类提供的函数  
  
//这段代码是用于控制一个名为MyCobot的机械臂的，特别是关于其关节角度控制和坐标控制。
//代码中使用了MyCobotBasic这个类，该类提供了与MyCobot机械臂交互的接口。

#include <MyCobotBasic.h> // 引入MyCobotBasic库，以便使用该类提供的函数
MyCobotBasic myCobot; // 创建MyCobotBasic类的实例，用于后续控制机械臂  
  
// 定义一个Coords类型的变量并初始化为特定的坐标值  
// 这些值可能代表机械臂末端执行器在某一参考坐标系下的位置和方向  
Coords coords = {194.700,-67.400,131.300,-177.260,-3.760,-110.880};  
  
// setup()函数在Arduino板子上电或重置后自动执行一次  
void setup()  
{  
    myCobot.setup(); // 调用myCobot的setup()函数，这个函数通常用于初始化与机械臂的连接或配置  
    delay(100); // 等待100毫秒，确保初始化完成  
    myCobot.powerOn(); // 打开机械臂的电源  
    delay(100); // 等待100毫秒，确保电源稳定  
      
    // 将机械臂的关节角度设置为初始姿态，以便从一个已知的状态开始坐标控制  
    // 注意：这里的关节角度值（{0, -10, -123, 45, 0, 20}）是示例值，实际值取决于机械臂的具体配置  
    myCobot.writeAngles({0, -10, -123, 45, 0, 20}, 50); // 初始姿态的关节角度控制，速度为50  
    delay(6000); // 等待6000毫秒（6秒），确保机械臂到达初始姿态  
}  
  
// loop()函数在setup()函数执行完后不断循环执行  
void loop()  
{  
    // 控制机械臂沿X轴（假设Axis枚举中1代表X轴）移动30mm，速度为30（速度单位可能是百分比或其他）  
    myCobot.writeCoord((Axis)1, 30, 30); // 单坐标控制，X轴到30mm，速度为30  
    delay(300); // 等待300毫秒，让机械臂移动到指定位置  
      
    // 将机械臂的末端执行器移动到coords变量指定的坐标位置，速度为30  
    // 注意：这里的coords变量包含了六个值，可能分别代表X、Y、Z位置以及绕这三个轴的旋转角度  
    myCobot.writeCoords(coords, 30); // 多坐标控制，移动到coords指定的位置，速度为30  
    delay(5000); // 等待5000毫秒（5秒），可能是为了观察机械臂的移动效果或进行调试  
      
    // 由于loop函数是不断循环的，所以上述动作会不断重复执行  
    // 如果想要执行一次后停止，可以在执行完毕后添加某种形式的退出条件（例如，使用一个标志变量）  
}
