//这段代码是用于控制一个名为MyCobot的机械臂的夹爪（gripper）的开合动作以及角度的。它使用了MyCobotBasic这个类来与机械臂进行交互。

#include <MyCobotBasic.h> // 引入MyCobotBasic库，以便使用该类提供的函数来控制MyCobot机械臂  
  
MyCobotBasic myCobot; // 创建MyCobotBasic类的实例，用于后续控制机械臂  
  
// setup()函数在Arduino板子上电或重置后自动执行一次  
void setup()  
{  
    myCobot.setup(); // 调用myCobot的setup()函数，这个函数通常用于初始化与机械臂的连接或配置  
    delay(100); // 等待100毫秒，确保初始化完成  
    myCobot.powerOn(); // 打开机械臂的电源  
    delay(100); // 等待100毫秒，确保电源稳定  
}  
  
// loop()函数在setup()函数执行完后不断循环执行  
void loop()  
{  
    // 设置夹爪的角度为80°，以50的速度进行（这里的速度单位可能是百分比、角度/秒等，具体取决于库的实现）  
    myCobot.setGripperValue(80, 50); // let the gripper to 80°, speed 50  
    delay(500); // 等待500毫秒，让夹爪移动到指定角度  
      
    // 设置夹爪的角度为20°，以50的速度进行  
    myCobot.setGripperValue(20, 50); // let the gripper to 20°, speed 50  
    delay(500); // 再次等待500毫秒  
      
    // 打开夹爪，以30的速度进行（这里的“速度”可能是指夹爪打开或关闭的速率）  
    // 注意：这里的0可能是一个标志，表示“打开”状态  
    myCobot.setGripperState(0, 30); // open the gripper, speed 30  
    delay(600); // 等待600毫秒，让夹爪完全打开  
      
    // 关闭夹爪，以30的速度进行  
    // 注意：这里的1可能是一个标志，表示“关闭”状态  
    myCobot.setGripperState(1, 30); // close the gripper, speed 30  
    delay(600); // 等待600毫秒，让夹爪完全关闭  
      
    // 由于loop函数是不断循环的，所以上述动作会不断重复执行  
    // 如果想要执行一次后停止，可以在执行完毕后添加某种形式的退出条件（例如，使用一个标志变量）  
}
